from typing import Generic, TypeVar
from .result import Result
from .parser import Parser


P = TypeVar("P")
class FwDeclaration(Generic[P]):
    parser: None | Parser[P]

    def __init__(self) -> None:
        self.parser = None

    def p(self):
        def inner(stream: str, index: int) -> Result[P]:
            if self.parser is None:
                raise Exception("Using forwarded definition of parser without defining first.")
            return self.parser.inner(stream, index)
        return Parser(inner)

    def define(self, parser: Parser[P]):
        if self.parser is not None:
            raise Exception("Redefinition of parser.")
        self.parser = parser
